#!/usr/bin/perl

use strict;
use warnings;

use File::Basename;
use Cwd qw/abs_path/;

open F, "/bin/find include -type f |";
print "\t--absolute-names \\\n";
while(my $dst = <F>) {
	chomp $dst;
	open I, $dst;
	my $content = join("", <I>);
	close I;

	if( $content =~ m|^#include "(.*)"\s*$| ) {
		my $i = $1;
		if( $i =~ m#../qtwebengine# ) {
			my $src = abs_path(dirname($dst) . "/" . $i);
			die "src $src not found" unless -f $src;
			print "\t--xform s,$src,$dst, \\\n\t$src \\\n";
			next;
		}
	}

	print "\t$dst \\\n";
}
close F;

my $base = `cygpath -am .`;
my $basew = `cygpath -aw . | sed -e 's/\\\\/&&/g'`;

chomp $base;
chomp $basew;

open F, "grep -rl build-x86 mkspecs |";
while(my $dst = <F>) {
	chomp $dst;
	my $b = basename($dst);
	system "sed"
		. " -e 's#$base/bin#\$\$[QT_INSTALL_BINS]#g'"
		. " -e 's#$basew\\\\bin#\$\$[QT_INSTALL_BINS]#g'"
	       	. " -e 's#$base/include#\$\$[QT_INSTALL_HEADERS]#g'"
	       	. " -e 's#$base/lib#\$\$[QT_INSTALL_LIBS]#g'"
	       	. " -e 's#$base/plugins#\$\$[QT_INSTALL_PLUGINS]#g'"
	       	. " -e 's#$base/mkspecs/modules-inst/#../modules-inst/#g'"
	       	. " '$dst' >../$b\n";
	print "\t--exclude $dst \\\n\t--xform s,../$b,$dst, \\\n\t../$b \\\n";
}
close F;
